/*****************************************************************************
              PUTIMG - Display a DT2851 image from disk
	Copyright (C) 1997..1999 Walter Fetter Lages <w.fetter@ieee.org>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*****************************************************************************/

#include <fstream.h>
#include <iostream.h>

#include <dt2851.h>

static const int BOARD=0;
static const unsigned long BASE_MEM=0xd00000ul;
static const unsigned int BASE_IO=0x230;

int main(int argc,char *argv[])
{
	cout << "\nPUTIMG - Display a DT2851 image from disk.\n";
	cout << "Copyright (C) 1997..1999 Walter Fetter Lages <w.fetter@ieee.org>.\n\n";
	if (argc != 2)
	{
		cout << "Usage: PUTIMG imgfile\n\n";
		return -1;
	}

/* DT2851 initialization */

	setbaseadd51(BOARD,BASE_MEM,BASE_IO);
	init51();
	selectoutbuf51(BOARD,0);
	selectinbuf51(BOARD,0);
	settiming51(BOARD,EXTTIM51);
	setmode51(BOARD,VIDEO_IN51);
	setdisplay51(BOARD,1);

/* read image from disk */

	ifstream imgfile(argv[1],ios::in|ios::bin);
	if (!imgfile)
	{
		cout << "Can't open input file.\n\n";
		return -2;
	}
	for(int y=0;y < 480;y++)
	{
		line51 line;
		imgfile.read(line,sizeof(line));
		writeline51(BOARD,0,y,line);
	}

/* Release DT2851 */
	close51();

	return 0;

}

